t / test-lib.shon commit Merge branch 'mm/complete-rebase-autostash' (1e7ef5d)
   1# Test framework for git.  See t/README for usage.
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Keep the original TERM for say_color
  19ORIGINAL_TERM=$TERM
  20
  21# Test the binaries we have just built.  The tests are kept in
  22# t/ subdirectory and are run in 'trash directory' subdirectory.
  23if test -z "$TEST_DIRECTORY"
  24then
  25        # We allow tests to override this, in case they want to run tests
  26        # outside of t/, e.g. for running tests on the test library
  27        # itself.
  28        TEST_DIRECTORY=$(pwd)
  29else
  30        # ensure that TEST_DIRECTORY is an absolute path so that it
  31        # is valid even if the current working directory is changed
  32        TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
  33fi
  34if test -z "$TEST_OUTPUT_DIRECTORY"
  35then
  36        # Similarly, override this to store the test-results subdir
  37        # elsewhere
  38        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  39fi
  40GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  41
  42################################################################
  43# It appears that people try to run tests without building...
  44"$GIT_BUILD_DIR/git" >/dev/null
  45if test $? != 1
  46then
  47        echo >&2 'error: you do not seem to have built git yet.'
  48        exit 1
  49fi
  50
  51. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  52export PERL_PATH SHELL_PATH
  53
  54# if --tee was passed, write the output not only to the terminal, but
  55# additionally to the file test-results/$BASENAME.out, too.
  56case "$GIT_TEST_TEE_STARTED, $* " in
  57done,*)
  58        # do not redirect again
  59        ;;
  60*' --tee '*|*' --va'*)
  61        mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
  62        BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
  63        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  64         echo $? > $BASE.exit) | tee $BASE.out
  65        test "$(cat $BASE.exit)" = 0
  66        exit
  67        ;;
  68esac
  69
  70# For repeatability, reset the environment to known value.
  71LANG=C
  72LC_ALL=C
  73PAGER=cat
  74TZ=UTC
  75TERM=dumb
  76export LANG LC_ALL PAGER TERM TZ
  77EDITOR=:
  78# A call to "unset" with no arguments causes at least Solaris 10
  79# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  80# deriving from the command substitution clustered with the other
  81# ones.
  82unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  83        my @env = keys %ENV;
  84        my $ok = join("|", qw(
  85                TRACE
  86                DEBUG
  87                USE_LOOKUP
  88                TEST
  89                .*_TEST
  90                PROVE
  91                VALGRIND
  92                UNZIP
  93                PERF_
  94                CURL_VERBOSE
  95        ));
  96        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  97        print join("\n", @vars);
  98')
  99unset XDG_CONFIG_HOME
 100unset GITPERLLIB
 101GIT_AUTHOR_EMAIL=author@example.com
 102GIT_AUTHOR_NAME='A U Thor'
 103GIT_COMMITTER_EMAIL=committer@example.com
 104GIT_COMMITTER_NAME='C O Mitter'
 105GIT_MERGE_VERBOSITY=5
 106GIT_MERGE_AUTOEDIT=no
 107export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 108export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 109export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 110export EDITOR
 111
 112# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
 113GIT_TRACE_BARE=1
 114export GIT_TRACE_BARE
 115
 116if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
 117then
 118        GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
 119        export GIT_INDEX_VERSION
 120fi
 121
 122# Add libc MALLOC and MALLOC_PERTURB test
 123# only if we are not executing the test with valgrind
 124if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 125   test -n "$TEST_NO_MALLOC_CHECK"
 126then
 127        setup_malloc_check () {
 128                : nothing
 129        }
 130        teardown_malloc_check () {
 131                : nothing
 132        }
 133else
 134        setup_malloc_check () {
 135                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 136                export MALLOC_CHECK_ MALLOC_PERTURB_
 137        }
 138        teardown_malloc_check () {
 139                unset MALLOC_CHECK_ MALLOC_PERTURB_
 140        }
 141fi
 142
 143: ${ASAN_OPTIONS=detect_leaks=0}
 144export ASAN_OPTIONS
 145
 146# Protect ourselves from common misconfiguration to export
 147# CDPATH into the environment
 148unset CDPATH
 149
 150unset GREP_OPTIONS
 151unset UNZIP
 152
 153case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1541|2|true)
 155        echo "* warning: Some tests will not work if GIT_TRACE" \
 156                "is set as to trace on STDERR ! *"
 157        echo "* warning: Please set GIT_TRACE to something" \
 158                "other than 1, 2 or true ! *"
 159        ;;
 160esac
 161
 162# Convenience
 163#
 164# A regexp to match 5 and 40 hexdigits
 165_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 166_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 167
 168# Zero SHA-1
 169_z40=0000000000000000000000000000000000000000
 170
 171# Line feed
 172LF='
 173'
 174
 175# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
 176# when case-folding filenames
 177u200c=$(printf '\342\200\214')
 178
 179export _x05 _x40 _z40 LF u200c
 180
 181# Each test should start with something like this, after copyright notices:
 182#
 183# test_description='Description of this test...
 184# This test checks if command xyzzy does the right thing...
 185# '
 186# . ./test-lib.sh
 187[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 188                TERM=$ORIGINAL_TERM &&
 189                export TERM &&
 190                [ -t 1 ] &&
 191                tput bold >/dev/null 2>&1 &&
 192                tput setaf 1 >/dev/null 2>&1 &&
 193                tput sgr0 >/dev/null 2>&1
 194        ) &&
 195        color=t
 196
 197while test "$#" -ne 0
 198do
 199        case "$1" in
 200        -d|--d|--de|--deb|--debu|--debug)
 201                debug=t; shift ;;
 202        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 203                immediate=t; shift ;;
 204        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 205                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 206        -r)
 207                shift; test "$#" -ne 0 || {
 208                        echo 'error: -r requires an argument' >&2;
 209                        exit 1;
 210                }
 211                run_list=$1; shift ;;
 212        --run=*)
 213                run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
 214        -h|--h|--he|--hel|--help)
 215                help=t; shift ;;
 216        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 217                verbose=t; shift ;;
 218        --verbose-only=*)
 219                verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
 220                shift ;;
 221        -q|--q|--qu|--qui|--quie|--quiet)
 222                # Ignore --quiet under a TAP::Harness. Saying how many tests
 223                # passed without the ok/not ok details is always an error.
 224                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 225        --with-dashes)
 226                with_dashes=t; shift ;;
 227        --no-color)
 228                color=; shift ;;
 229        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 230                valgrind=memcheck
 231                shift ;;
 232        --valgrind=*)
 233                valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
 234                shift ;;
 235        --valgrind-only=*)
 236                valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
 237                shift ;;
 238        --tee)
 239                shift ;; # was handled already
 240        --root=*)
 241                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 242                shift ;;
 243        -x)
 244                trace=t
 245                verbose=t
 246                shift ;;
 247        *)
 248                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 249        esac
 250done
 251
 252if test -n "$valgrind_only"
 253then
 254        test -z "$valgrind" && valgrind=memcheck
 255        test -z "$verbose" && verbose_only="$valgrind_only"
 256elif test -n "$valgrind"
 257then
 258        verbose=t
 259fi
 260
 261if test -n "$color"
 262then
 263        say_color () {
 264                (
 265                TERM=$ORIGINAL_TERM
 266                export TERM
 267                case "$1" in
 268                error)
 269                        tput bold; tput setaf 1;; # bold red
 270                skip)
 271                        tput setaf 4;; # blue
 272                warn)
 273                        tput setaf 3;; # brown/yellow
 274                pass)
 275                        tput setaf 2;; # green
 276                info)
 277                        tput setaf 6;; # cyan
 278                *)
 279                        test -n "$quiet" && return;;
 280                esac
 281                shift
 282                printf "%s" "$*"
 283                tput sgr0
 284                echo
 285                )
 286        }
 287else
 288        say_color() {
 289                test -z "$1" && test -n "$quiet" && return
 290                shift
 291                printf "%s\n" "$*"
 292        }
 293fi
 294
 295error () {
 296        say_color error "error: $*"
 297        GIT_EXIT_OK=t
 298        exit 1
 299}
 300
 301say () {
 302        say_color info "$*"
 303}
 304
 305test "${test_description}" != "" ||
 306error "Test script did not set test_description."
 307
 308if test "$help" = "t"
 309then
 310        printf '%s\n' "$test_description"
 311        exit 0
 312fi
 313
 314exec 5>&1
 315exec 6<&0
 316if test "$verbose" = "t"
 317then
 318        exec 4>&2 3>&1
 319else
 320        exec 4>/dev/null 3>/dev/null
 321fi
 322
 323test_failure=0
 324test_count=0
 325test_fixed=0
 326test_broken=0
 327test_success=0
 328
 329test_external_has_tap=0
 330
 331die () {
 332        code=$?
 333        if test -n "$GIT_EXIT_OK"
 334        then
 335                exit $code
 336        else
 337                echo >&5 "FATAL: Unexpected exit with code $code"
 338                exit 1
 339        fi
 340}
 341
 342GIT_EXIT_OK=
 343trap 'die' EXIT
 344
 345# The user-facing functions are loaded from a separate file so that
 346# test_perf subshells can have them too
 347. "$TEST_DIRECTORY/test-lib-functions.sh"
 348
 349# You are not expected to call test_ok_ and test_failure_ directly, use
 350# the test_expect_* functions instead.
 351
 352test_ok_ () {
 353        test_success=$(($test_success + 1))
 354        say_color "" "ok $test_count - $@"
 355}
 356
 357test_failure_ () {
 358        test_failure=$(($test_failure + 1))
 359        say_color error "not ok $test_count - $1"
 360        shift
 361        printf '%s\n' "$*" | sed -e 's/^/#      /'
 362        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 363}
 364
 365test_known_broken_ok_ () {
 366        test_fixed=$(($test_fixed+1))
 367        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 368}
 369
 370test_known_broken_failure_ () {
 371        test_broken=$(($test_broken+1))
 372        say_color warn "not ok $test_count - $@ # TODO known breakage"
 373}
 374
 375test_debug () {
 376        test "$debug" = "" || eval "$1"
 377}
 378
 379match_pattern_list () {
 380        arg="$1"
 381        shift
 382        test -z "$*" && return 1
 383        for pattern_
 384        do
 385                case "$arg" in
 386                $pattern_)
 387                        return 0
 388                esac
 389        done
 390        return 1
 391}
 392
 393match_test_selector_list () {
 394        title="$1"
 395        shift
 396        arg="$1"
 397        shift
 398        test -z "$1" && return 0
 399
 400        # Both commas and whitespace are accepted as separators.
 401        OLDIFS=$IFS
 402        IFS='   ,'
 403        set -- $1
 404        IFS=$OLDIFS
 405
 406        # If the first selector is negative we include by default.
 407        include=
 408        case "$1" in
 409                !*) include=t ;;
 410        esac
 411
 412        for selector
 413        do
 414                orig_selector=$selector
 415
 416                positive=t
 417                case "$selector" in
 418                        !*)
 419                                positive=
 420                                selector=${selector##?}
 421                                ;;
 422                esac
 423
 424                test -z "$selector" && continue
 425
 426                case "$selector" in
 427                        *-*)
 428                                if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
 429                                then
 430                                        echo "error: $title: invalid non-numeric in range" \
 431                                                "start: '$orig_selector'" >&2
 432                                        exit 1
 433                                fi
 434                                if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
 435                                then
 436                                        echo "error: $title: invalid non-numeric in range" \
 437                                                "end: '$orig_selector'" >&2
 438                                        exit 1
 439                                fi
 440                                ;;
 441                        *)
 442                                if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
 443                                then
 444                                        echo "error: $title: invalid non-numeric in test" \
 445                                                "selector: '$orig_selector'" >&2
 446                                        exit 1
 447                                fi
 448                esac
 449
 450                # Short cut for "obvious" cases
 451                test -z "$include" && test -z "$positive" && continue
 452                test -n "$include" && test -n "$positive" && continue
 453
 454                case "$selector" in
 455                        -*)
 456                                if test $arg -le ${selector#-}
 457                                then
 458                                        include=$positive
 459                                fi
 460                                ;;
 461                        *-)
 462                                if test $arg -ge ${selector%-}
 463                                then
 464                                        include=$positive
 465                                fi
 466                                ;;
 467                        *-*)
 468                                if test ${selector%%-*} -le $arg \
 469                                        && test $arg -le ${selector#*-}
 470                                then
 471                                        include=$positive
 472                                fi
 473                                ;;
 474                        *)
 475                                if test $arg -eq $selector
 476                                then
 477                                        include=$positive
 478                                fi
 479                                ;;
 480                esac
 481        done
 482
 483        test -n "$include"
 484}
 485
 486maybe_teardown_verbose () {
 487        test -z "$verbose_only" && return
 488        exec 4>/dev/null 3>/dev/null
 489        verbose=
 490}
 491
 492last_verbose=t
 493maybe_setup_verbose () {
 494        test -z "$verbose_only" && return
 495        if match_pattern_list $test_count $verbose_only
 496        then
 497                exec 4>&2 3>&1
 498                # Emit a delimiting blank line when going from
 499                # non-verbose to verbose.  Within verbose mode the
 500                # delimiter is printed by test_expect_*.  The choice
 501                # of the initial $last_verbose is such that before
 502                # test 1, we do not print it.
 503                test -z "$last_verbose" && echo >&3 ""
 504                verbose=t
 505        else
 506                exec 4>/dev/null 3>/dev/null
 507                verbose=
 508        fi
 509        last_verbose=$verbose
 510}
 511
 512maybe_teardown_valgrind () {
 513        test -z "$GIT_VALGRIND" && return
 514        GIT_VALGRIND_ENABLED=
 515}
 516
 517maybe_setup_valgrind () {
 518        test -z "$GIT_VALGRIND" && return
 519        if test -z "$valgrind_only"
 520        then
 521                GIT_VALGRIND_ENABLED=t
 522                return
 523        fi
 524        GIT_VALGRIND_ENABLED=
 525        if match_pattern_list $test_count $valgrind_only
 526        then
 527                GIT_VALGRIND_ENABLED=t
 528        fi
 529}
 530
 531# This is a separate function because some tests use
 532# "return" to end a test_expect_success block early
 533# (and we want to make sure we run any cleanup like
 534# "set +x").
 535test_eval_inner_ () {
 536        # Do not add anything extra (including LF) after '$*'
 537        eval "
 538                test \"$trace\" = t && set -x
 539                $*"
 540}
 541
 542test_eval_ () {
 543        # We run this block with stderr redirected to avoid extra cruft
 544        # during a "-x" trace. Once in "set -x" mode, we cannot prevent
 545        # the shell from printing the "set +x" to turn it off (nor the saving
 546        # of $? before that). But we can make sure that the output goes to
 547        # /dev/null.
 548        #
 549        # The test itself is run with stderr put back to &4 (so either to
 550        # /dev/null, or to the original stderr if --verbose was used).
 551        {
 552                test_eval_inner_ "$@" </dev/null >&3 2>&4
 553                test_eval_ret_=$?
 554                if test "$trace" = t
 555                then
 556                        set +x
 557                        if test "$test_eval_ret_" != 0
 558                        then
 559                                say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
 560                        fi
 561                fi
 562        } 2>/dev/null
 563        return $test_eval_ret_
 564}
 565
 566test_run_ () {
 567        test_cleanup=:
 568        expecting_failure=$2
 569        setup_malloc_check
 570        test_eval_ "$1"
 571        eval_ret=$?
 572        teardown_malloc_check
 573
 574        if test -z "$immediate" || test $eval_ret = 0 ||
 575           test -n "$expecting_failure" && test "$test_cleanup" != ":"
 576        then
 577                setup_malloc_check
 578                test_eval_ "$test_cleanup"
 579                teardown_malloc_check
 580        fi
 581        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 582        then
 583                echo ""
 584        fi
 585        return "$eval_ret"
 586}
 587
 588test_start_ () {
 589        test_count=$(($test_count+1))
 590        maybe_setup_verbose
 591        maybe_setup_valgrind
 592}
 593
 594test_finish_ () {
 595        echo >&3 ""
 596        maybe_teardown_valgrind
 597        maybe_teardown_verbose
 598}
 599
 600test_skip () {
 601        to_skip=
 602        skipped_reason=
 603        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 604        then
 605                to_skip=t
 606                skipped_reason="GIT_SKIP_TESTS"
 607        fi
 608        if test -z "$to_skip" && test -n "$test_prereq" &&
 609           ! test_have_prereq "$test_prereq"
 610        then
 611                to_skip=t
 612
 613                of_prereq=
 614                if test "$missing_prereq" != "$test_prereq"
 615                then
 616                        of_prereq=" of $test_prereq"
 617                fi
 618                skipped_reason="missing $missing_prereq${of_prereq}"
 619        fi
 620        if test -z "$to_skip" && test -n "$run_list" &&
 621                ! match_test_selector_list '--run' $test_count "$run_list"
 622        then
 623                to_skip=t
 624                skipped_reason="--run"
 625        fi
 626
 627        case "$to_skip" in
 628        t)
 629                say_color skip >&3 "skipping test: $@"
 630                say_color skip "ok $test_count # skip $1 ($skipped_reason)"
 631                : true
 632                ;;
 633        *)
 634                false
 635                ;;
 636        esac
 637}
 638
 639# stub; perf-lib overrides it
 640test_at_end_hook_ () {
 641        :
 642}
 643
 644test_done () {
 645        GIT_EXIT_OK=t
 646
 647        if test -z "$HARNESS_ACTIVE"
 648        then
 649                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 650                mkdir -p "$test_results_dir"
 651                base=${0##*/}
 652                test_results_path="$test_results_dir/${base%.sh}-$$.counts"
 653
 654                cat >>"$test_results_path" <<-EOF
 655                total $test_count
 656                success $test_success
 657                fixed $test_fixed
 658                broken $test_broken
 659                failed $test_failure
 660
 661                EOF
 662        fi
 663
 664        if test "$test_fixed" != 0
 665        then
 666                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 667        fi
 668        if test "$test_broken" != 0
 669        then
 670                say_color warn "# still have $test_broken known breakage(s)"
 671        fi
 672        if test "$test_broken" != 0 || test "$test_fixed" != 0
 673        then
 674                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 675                msg="remaining $test_remaining test(s)"
 676        else
 677                test_remaining=$test_count
 678                msg="$test_count test(s)"
 679        fi
 680        case "$test_failure" in
 681        0)
 682                # Maybe print SKIP message
 683                if test -n "$skip_all" && test $test_count -gt 0
 684                then
 685                        error "Can't use skip_all after running some tests"
 686                fi
 687                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 688
 689                if test $test_external_has_tap -eq 0
 690                then
 691                        if test $test_remaining -gt 0
 692                        then
 693                                say_color pass "# passed all $msg"
 694                        fi
 695                        say "1..$test_count$skip_all"
 696                fi
 697
 698                test -d "$remove_trash" &&
 699                cd "$(dirname "$remove_trash")" &&
 700                rm -rf "$(basename "$remove_trash")"
 701
 702                test_at_end_hook_
 703
 704                exit 0 ;;
 705
 706        *)
 707                if test $test_external_has_tap -eq 0
 708                then
 709                        say_color error "# failed $test_failure among $msg"
 710                        say "1..$test_count"
 711                fi
 712
 713                exit 1 ;;
 714
 715        esac
 716}
 717
 718if test -n "$valgrind"
 719then
 720        make_symlink () {
 721                test -h "$2" &&
 722                test "$1" = "$(readlink "$2")" || {
 723                        # be super paranoid
 724                        if mkdir "$2".lock
 725                        then
 726                                rm -f "$2" &&
 727                                ln -s "$1" "$2" &&
 728                                rm -r "$2".lock
 729                        else
 730                                while test -d "$2".lock
 731                                do
 732                                        say "Waiting for lock on $2."
 733                                        sleep 1
 734                                done
 735                        fi
 736                }
 737        }
 738
 739        make_valgrind_symlink () {
 740                # handle only executables, unless they are shell libraries that
 741                # need to be in the exec-path.
 742                test -x "$1" ||
 743                test "# " = "$(head -c 2 <"$1")" ||
 744                return;
 745
 746                base=$(basename "$1")
 747                symlink_target=$GIT_BUILD_DIR/$base
 748                # do not override scripts
 749                if test -x "$symlink_target" &&
 750                    test ! -d "$symlink_target" &&
 751                    test "#!" != "$(head -c 2 < "$symlink_target")"
 752                then
 753                        symlink_target=../valgrind.sh
 754                fi
 755                case "$base" in
 756                *.sh|*.perl)
 757                        symlink_target=../unprocessed-script
 758                esac
 759                # create the link, or replace it if it is out of date
 760                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 761        }
 762
 763        # override all git executables in TEST_DIRECTORY/..
 764        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 765        mkdir -p "$GIT_VALGRIND"/bin
 766        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 767        do
 768                make_valgrind_symlink $file
 769        done
 770        # special-case the mergetools loadables
 771        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 772        OLDIFS=$IFS
 773        IFS=:
 774        for path in $PATH
 775        do
 776                ls "$path"/git-* 2> /dev/null |
 777                while read file
 778                do
 779                        make_valgrind_symlink "$file"
 780                done
 781        done
 782        IFS=$OLDIFS
 783        PATH=$GIT_VALGRIND/bin:$PATH
 784        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 785        export GIT_VALGRIND
 786        GIT_VALGRIND_MODE="$valgrind"
 787        export GIT_VALGRIND_MODE
 788        GIT_VALGRIND_ENABLED=t
 789        test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
 790        export GIT_VALGRIND_ENABLED
 791elif test -n "$GIT_TEST_INSTALLED"
 792then
 793        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 794        error "Cannot run git from $GIT_TEST_INSTALLED."
 795        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 796        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 797else # normal case, use ../bin-wrappers only unless $with_dashes:
 798        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 799        if ! test -x "$git_bin_dir/git"
 800        then
 801                if test -z "$with_dashes"
 802                then
 803                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 804                fi
 805                with_dashes=t
 806        fi
 807        PATH="$git_bin_dir:$PATH"
 808        GIT_EXEC_PATH=$GIT_BUILD_DIR
 809        if test -n "$with_dashes"
 810        then
 811                PATH="$GIT_BUILD_DIR:$PATH"
 812        fi
 813fi
 814GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 815GIT_CONFIG_NOSYSTEM=1
 816GIT_ATTR_NOSYSTEM=1
 817export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 818
 819if test -z "$GIT_TEST_CMP"
 820then
 821        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 822        then
 823                GIT_TEST_CMP="$DIFF -c"
 824        else
 825                GIT_TEST_CMP="$DIFF -u"
 826        fi
 827fi
 828
 829GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 830export GITPERLLIB
 831test -d "$GIT_BUILD_DIR"/templates/blt || {
 832        error "You haven't built things yet, have you?"
 833}
 834
 835if ! test -x "$GIT_BUILD_DIR"/test-chmtime
 836then
 837        echo >&2 'You need to build test-chmtime:'
 838        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 839        exit 1
 840fi
 841
 842# Test repository
 843TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 844test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 845case "$TRASH_DIRECTORY" in
 846/*) ;; # absolute path is good
 847 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 848esac
 849test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 850rm -fr "$TRASH_DIRECTORY" || {
 851        GIT_EXIT_OK=t
 852        echo >&5 "FATAL: Cannot prepare test area"
 853        exit 1
 854}
 855
 856HOME="$TRASH_DIRECTORY"
 857GNUPGHOME="$HOME/gnupg-home-not-used"
 858export HOME GNUPGHOME
 859
 860if test -z "$TEST_NO_CREATE_REPO"
 861then
 862        test_create_repo "$TRASH_DIRECTORY"
 863else
 864        mkdir -p "$TRASH_DIRECTORY"
 865fi
 866# Use -P to resolve symlinks in our working directory so that the cwd
 867# in subprocesses like git equals our $PWD (for pathname comparisons).
 868cd -P "$TRASH_DIRECTORY" || exit 1
 869
 870this_test=${0##*/}
 871this_test=${this_test%%-*}
 872if match_pattern_list "$this_test" $GIT_SKIP_TESTS
 873then
 874        say_color info >&3 "skipping test $this_test altogether"
 875        skip_all="skip all tests in $this_test"
 876        test_done
 877fi
 878
 879# Provide an implementation of the 'yes' utility
 880yes () {
 881        if test $# = 0
 882        then
 883                y=y
 884        else
 885                y="$*"
 886        fi
 887
 888        while echo "$y"
 889        do
 890                :
 891        done
 892}
 893
 894# Fix some commands on Windows
 895case $(uname -s) in
 896*MINGW*)
 897        # Windows has its own (incompatible) sort and find
 898        sort () {
 899                /usr/bin/sort "$@"
 900        }
 901        find () {
 902                /usr/bin/find "$@"
 903        }
 904        sum () {
 905                md5sum "$@"
 906        }
 907        # git sees Windows-style pwd
 908        pwd () {
 909                builtin pwd -W
 910        }
 911        # no POSIX permissions
 912        # backslashes in pathspec are converted to '/'
 913        # exec does not inherit the PID
 914        test_set_prereq MINGW
 915        test_set_prereq NATIVE_CRLF
 916        test_set_prereq SED_STRIPS_CR
 917        test_set_prereq GREP_STRIPS_CR
 918        GIT_TEST_CMP=mingw_test_cmp
 919        ;;
 920*CYGWIN*)
 921        test_set_prereq POSIXPERM
 922        test_set_prereq EXECKEEPSPID
 923        test_set_prereq CYGWIN
 924        test_set_prereq SED_STRIPS_CR
 925        test_set_prereq GREP_STRIPS_CR
 926        ;;
 927*)
 928        test_set_prereq POSIXPERM
 929        test_set_prereq BSLASHPSPEC
 930        test_set_prereq EXECKEEPSPID
 931        ;;
 932esac
 933
 934( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
 935test -z "$NO_PERL" && test_set_prereq PERL
 936test -z "$NO_PYTHON" && test_set_prereq PYTHON
 937test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 938test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 939
 940# Can we rely on git's output in the C locale?
 941if test -n "$GETTEXT_POISON"
 942then
 943        GIT_GETTEXT_POISON=YesPlease
 944        export GIT_GETTEXT_POISON
 945        test_set_prereq GETTEXT_POISON
 946else
 947        test_set_prereq C_LOCALE_OUTPUT
 948fi
 949
 950# Use this instead of test_cmp to compare files that contain expected and
 951# actual output from git commands that can be translated.  When running
 952# under GETTEXT_POISON this pretends that the command produced expected
 953# results.
 954test_i18ncmp () {
 955        test -n "$GETTEXT_POISON" || test_cmp "$@"
 956}
 957
 958# Use this instead of "grep expected-string actual" to see if the
 959# output from a git command that can be translated either contains an
 960# expected string, or does not contain an unwanted one.  When running
 961# under GETTEXT_POISON this pretends that the command produced expected
 962# results.
 963test_i18ngrep () {
 964        if test -n "$GETTEXT_POISON"
 965        then
 966            : # pretend success
 967        elif test "x!" = "x$1"
 968        then
 969                shift
 970                ! grep "$@"
 971        else
 972                grep "$@"
 973        fi
 974}
 975
 976test_lazy_prereq PIPE '
 977        # test whether the filesystem supports FIFOs
 978        case $(uname -s) in
 979        CYGWIN*)
 980                false
 981                ;;
 982        *)
 983                rm -f testfifo && mkfifo testfifo
 984                ;;
 985        esac
 986'
 987
 988test_lazy_prereq SYMLINKS '
 989        # test whether the filesystem supports symbolic links
 990        ln -s x y && test -h y
 991'
 992
 993test_lazy_prereq FILEMODE '
 994        test "$(git config --bool core.filemode)" = true
 995'
 996
 997test_lazy_prereq CASE_INSENSITIVE_FS '
 998        echo good >CamelCase &&
 999        echo bad >camelcase &&
1000        test "$(cat CamelCase)" != good
1001'
1002
1003test_lazy_prereq UTF8_NFD_TO_NFC '
1004        # check whether FS converts nfd unicode to nfc
1005        auml=$(printf "\303\244")
1006        aumlcdiar=$(printf "\141\314\210")
1007        >"$auml" &&
1008        case "$(echo *)" in
1009        "$aumlcdiar")
1010                true ;;
1011        *)
1012                false ;;
1013        esac
1014'
1015
1016test_lazy_prereq AUTOIDENT '
1017        sane_unset GIT_AUTHOR_NAME &&
1018        sane_unset GIT_AUTHOR_EMAIL &&
1019        git var GIT_AUTHOR_IDENT
1020'
1021
1022test_lazy_prereq EXPENSIVE '
1023        test -n "$GIT_TEST_LONG"
1024'
1025
1026test_lazy_prereq USR_BIN_TIME '
1027        test -x /usr/bin/time
1028'
1029
1030# When the tests are run as root, permission tests will report that
1031# things are writable when they shouldn't be.
1032test -w / || test_set_prereq SANITY
1033
1034GIT_UNZIP=${GIT_UNZIP:-unzip}
1035test_lazy_prereq UNZIP '
1036        "$GIT_UNZIP" -v
1037        test $? -ne 127
1038'